/* --------------------------------------------------------
   @V~[gvO

                                     2003/09/5
                                         S.Mio
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* -------------------------------------------------------- */
#define TRUE  1
#define FALSE 0

/* -------------------------------------------------------- */
int state;  /* ʂϐ */

/* ʂɕtl */
#define STATE_INPUTWAIT    0  /* RC҂               */
#define STATE_COININSERT   1  /* RC RC̊mF  */
#define STATE_BUTTONPUT    2  /* {^ꂽ z̊mF  */
#define STATE_PUTTICKET    3  /*   ̊mF             */
#define STATE_PUTCHANGE    4  /* o               */
#define STATE_INPUTERROR   5  /* RCȂǂ̓̓G[     */
#define STATE_COINLIMIT    6  /* RCӂꂽƂ       */
#define STATE_ERROR        7  /* t[YׂG[   */
#define STATE_CANCEL       8  /* w̃LZ           */
#define STATE_EXIT         9  /* I                 */


/* -------------------------------------------------------- */
/* ͊֘A */
#define COINSTACKLIMIT  10
#define COINLIMIT       4
#define BUTTONLIMIT     5
int newcoin, newbutton, newticket, totalcoin;
int buttontable[BUTTONLIMIT] = {120, 150, 180, 210, 260};
int papercount;
int cointable[COINLIMIT] = {10, 50, 100, 500};
int coincount[COINLIMIT];             /* p̃RCJE^   */
int newcoinstack[COINSTACKLIMIT + 1]; /* ꂽRC̃X^bN */
int newcoinstacktop;                  /* X^bÑgbv           */
int changecount[COINLIMIT];           /* ԋp邨             */

/* ͂󂯕t */
void get_input(void)
{
    char s[256];
    int n;
    
    newcoin = -1;
    newbutton = -1;
    printf("ǂ(10, 50, 100, 500CX= Q=I)\n> ");
    gets(s);
    n = atoi(s);
    if (n == 0) {
        if (((s[0] >= 'A') && 
             (s[0] < 'A' + BUTTONLIMIT)) ||
             (s[0] == 'Q') || (s[0] == 'X'))
            newbutton = s[0];
    } else {
        newcoin = n;
    }
    printf("\n");
}

/* RCȊO */
int is_coininput(void)
{
    if (newcoin != -1)
        return TRUE;
    return FALSE;
}

/* {^ȊO */
int is_buttoninput(void)
{
    if (newbutton != -1)
        return TRUE;
    return FALSE;
}

/* lie[up̒lɕϊ */
int get_coinindex(int coin)
{
    int i;
    for (i = 0; i < COINLIMIT; i++) {
        if (cointable[i] == coin)
            return i;
    }
    return -1;
}

/* -------------------------------------------------------- */
/* ꂽRCobt@ɒuĂ */
int add_newcoin(int coin)
{
    if (newcoinstacktop >= COINSTACKLIMIT)
        return FALSE;
    newcoinstack[newcoinstacktop++] = coin;
    totalcoin += coin;
    return TRUE;
}

/* ꂽRCԋp */
void eject_newcoin(void)
{
    if (!is_coininput())
        return;
    printf("ԋp:\n");
    printf("%d~: 1\n", newcoin);
}

/* ܂܂œꂽRCԋp */
void alleject_newcoin(void)
{
    int i, coin, pos;
    int count[COINLIMIT];
    
    if (newcoinstacktop == 0)
        return;
    printf("ԋp:\n");
    for (i = 0; i < COINLIMIT; i++)
        count[i] = 0;
    for (i = 0; i < newcoinstacktop; i++) {
        coin = newcoinstack[i];
        pos = get_coinindex(coin);
        count[pos]++;
    }
    for (i = 0; i < COINLIMIT; i++) {
        if (count[i])
            printf("%d~: %d\n", cointable[i], count[i]);
    }
    totalcoin = 0;
    newcoinstacktop = 0;
}

/* X^bNɗ܂RCpJE^ɑ */
void newcoin_to_coincount(void)
{
    int i, coin, pos;
    
    for (i = 0; i < newcoinstacktop; i++) {
        coin = newcoinstack[i];
        pos = get_coinindex(coin);
        coincount[pos]++;
    }
}

/* ̊zԋpRC𓾂 */
/* Ԃl͂肪Ԃ邩ǂ */
int get_changecoin(int val)
{
    int i, coin, count;
    
    for (i = 0; i < COINLIMIT; i++)
        changecount[i] = 0;
    for (i = COINLIMIT-1; i >= 0; i--) {
        count = coincount[i];
        while (val >= cointable[i]) {
            if (count == 0)
                break;
            changecount[i]++;
            val -= cointable[i];
            count--;
        }
    }
    if (val)
        return FALSE;
    return TRUE;
}

/* Ԃ̃RC̐ */
void cointcount_dec_changecoin(void)
{
    int i;
    
    for (i = 0; i < COINLIMIT; i++) {
        coincount[i] -= changecount[i];
        changecount[i] = 0;
    }
    newcoinstacktop = 0;
}

/* -------------------------------------------------------- */
/* \֘A */

/* z̕\ */
void coinview(void)
{
    if (totalcoin)
        printf("z:  %d~\n", totalcoin);
}

/* zɉ{^̕\ */
void buttonview(void)
{
    int i;

    if (totalcoin < buttontable[0])
        return;
    printf("s: ");
    for (i = 0; i < BUTTONLIMIT; i++) {
        if (totalcoin >= buttontable[i]) {
            printf("%c(%d~) ", 'A' + i, buttontable[i]);
        } else {
            break;
        }
    }
    printf("\n");
}

/* -------------------------------------------------------- */
/* e */

/* RC/{^҂ */
void state_inputwait(void)
{
    coinview();
    buttonview();
    get_input();
    
    if (is_coininput()) {
        state = STATE_COININSERT;
    } else if (is_buttoninput()) {
        state = STATE_BUTTONPUT;
        if (newbutton == 'Q')
            state = STATE_EXIT;
        else if (newbutton == 'X')
            state = STATE_CANCEL;
    } else {
        /* RCł{^łȂ΃G[ */
        state = STATE_INPUTERROR;
    }
}

/* RCꂽ  */
void state_coininsert(void)
{
    int flagtruecoin, flagadd, i;
    
    flagtruecoin = FALSE;
    flagadd = FALSE;
    for (i = 0; i < COINLIMIT; i++) {
        if (newcoin == cointable[i]) {
            flagadd = add_newcoin(newcoin);
            flagtruecoin = TRUE;
            break;
        }
    }
    if (flagtruecoin) {
        if (!flagadd) {
            /* RC󂯕tȂ */
            /* RC1߂ */
            state = STATE_COINLIMIT;
        } else {
            state = STATE_INPUTWAIT;
        }
    } else {
        /* RCłȂ΃G[ */
        state = STATE_INPUTERROR;
    }
}

/* RCӂꂽƂ */
void state_coinlimiterror(void)
{
    printf("͂󂯕t܂\n");
    eject_newcoin();
    state = STATE_INPUTWAIT;
}

/* {^ꂽ z̊mF */
void state_buttonput(void)
{
    int i;

    if (totalcoin < cointable[0]) {
        state = STATE_INPUTWAIT;
        return;
    }
    for (i = 0; i < BUTTONLIMIT; i++) {
        if ((totalcoin >= buttontable[i]) && 
            (('A' + i) == newbutton)) {
            newticket = buttontable[i];
            state = STATE_PUTTICKET;
            return;
        }
    }
    state = STATE_INPUTWAIT;
}

/*  */
void state_putticket(void)
{
    printf("ؕ: %d~\n肪Ƃ܂\n\n", newticket);
    papercount--;
    totalcoin -= newticket;
    state = STATE_PUTCHANGE;
}

/* o */
void state_putchange(void)
{
    int i;

    /* ܂܂ł̂pJE^ɑ */
    newcoin_to_coincount();

    if (totalcoin) {
        /* o */
        if (!get_changecoin(totalcoin)) {
            printf("ނK؂\n");
            state = STATE_ERROR;
        } else {
            printf("\n");
            for (i = 0; i < COINLIMIT; i++) {
                if (changecount[i])
                    printf("%d~: %d\n", cointable[i],
                      changecount[i]);
            }
            cointcount_dec_changecoin();
            totalcoin = 0;
            printf("\n");
        }
    }
    /* ނK؂̊mF */
    /* 500-eԂ̂肪邩ǂ */
    for (i = 0; i < BUTTONLIMIT; i++) {
        if (!get_changecoin(500 - buttontable[i])) {
            printf("ނK؂\n");
            state = STATE_ERROR;
            return;
        }
    }
    /* ؂̊mF */
    if (!papercount) {
        printf("p؂\n");
        state = STATE_ERROR;
        return;
    }
    state = STATE_INPUTWAIT;
}

/* t[YׂG[ */
void state_error(void)
{
    eject_newcoin();
    alleject_newcoin();
    printf("肪܂B\nWĂт\n");
    state = STATE_EXIT;
}

/* RCȂǂ̓̓G[ */
void state_inputerror(void)
{
    eject_newcoin();
    state = STATE_INPUTWAIT;
}

/* w̃LZ */
void state_cancel(void)
{
    eject_newcoin();
    alleject_newcoin();
    state = STATE_INPUTWAIT;
}

/* -------------------------------------------------------- */
/* ֐ւ̃|C^̒` */
typedef void (*t_func)(void);

/* ʂƑΉ֐e[u */
t_func functable[] = {
    state_inputwait,
    state_coininsert,
    state_buttonput,
    state_putticket,
    state_putchange,
    state_inputerror,
    state_coinlimiterror,
    state_error,
    state_cancel,
};

/* -------------------------------------------------------- */
/* Ĩ`FbN */
int isEnd(void)
{
    if (state == STATE_EXIT)
        return TRUE;
    return FALSE;
}

/* -------------------------------------------------------- */
int main(void)
{
    int i;

    for (i = 0; i < COINLIMIT; i++)
        coincount[i] = 20;
    papercount = 10;
    newcoin = -1;
    newbutton = -1;
    newcoinstacktop = 0;
    state = STATE_INPUTWAIT;

    while (!isEnd()) {
        functable[state]();
    }
    return 0;
}
